//*****************************************
// AVR ATmega328 8x8 LED Clock
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:port_bit_h.h
//  wb_[t@C
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/01 Modify for pr_mega1284_8x8dot_clock Taishi
//  2022/10/10 add day_of_week Display Taishi
//  2023/02/01 Modify for pr_mega328_8x8dot_clock Taishi
//*****************************************

// XCb`
#define	SW_IN_PORT		(PINB)					// input switch port
#define	SW1_ON_BIT		(1 << PINB7)			// set switch
#define	SW2_ON_BIT		(1 << PINB6)			// select switch

// XCb`P̑ԁiWrbgj
#define			SW1_ON_NOW			0x0100		// XCb`PꂽB
#define			SW1_OFF_SHORT		0x0200		// XCb`PꂽBĂԂ͒Z
#define			SW1_OFF_LONG		0x0400		// XCb`PꂽBĂԂ͒
#define			SW1_ON_CONTINUE		0x0800		// XCb`PꑱĂBi莞ԊԊuł̒lxoj
#define			SW1_ON				0x1000		// XCb`PꑱĂBiĂ鎞͂̒loj
#define			SW1_MASK			0x1f00		// XCb`P̐M𒊏o

// XCb`Q̑ԁiWrbgj
#define			SW2_ON_NOW			0x01		// XCb`QꂽB
#define			SW2_OFF_SHORT		0x02		// XCb`QꂽBĂԂ͒Z
#define			SW2_OFF_LONG		0x04		// XCb`QꂽBĂԂ͒
#define			SW2_ON_CONTINUE		0x08		// XCb`QꑱĂBi莞ԊԊuł̒lxoj
#define			SW2_ON				0x10		// XCb`QꑱĂBiĂ鎞͂̒loj
#define			SW2_MASK			0x1f		// XCb`Q̐M𒊏o

#define			SW_MASK				0x1f1f		// XCb`̐M𒊏o

// kdc
//  red: LED5 LED(H=ON, L=OFF)
#define	led5_init()		DDRB |= (1 << DDB1)		// Port-B Bit1 : Output
#define	led5_on()		PORTB |=  (1 << PB1)	// LED ON
#define	led5_off()		PORTB &= ~(1 << PB1)	// LED OFF
#define	led5_toggle()	PORTB ^=  (1 << PB1)	// LED Toggle


extern	void			get_sw(void);
extern	void			sw_init(void);
extern	unsigned short	get_action_sw(void);
extern	void			wait_key_off(void);
extern	void			wait_sw_off(void);

// Dark signal
//
#define	dark_sig_init()		DDRC |= (1 << DDC3)		// Port-C Bit3 : Output
#define	dark_sig_on()		PORTC |=  (1 << PC3)	// Dark signal ON
#define	dark_sig_off()		PORTC &= ~(1 << PC3)	// Dark signal OFF
#define	dark_sig_toggle()	PORTC ^=  (1 << PC3)	// Dark signal Toggle


// Debug Signal
//  Signal: PORTD Bit2
#define	debsig_init()	DDRD |= (1 << DDD2)		// Port-D Bit2 : Output
#define	debsig_on()		PORTD |=  (1 << PD2)	// Signal High
#define	debsig_off()	PORTD &= ~(1 << PD2)	// Signal Low
#define	debsig_toggle()	PORTD ^=  (1 << PD2)	// Signal Toggle

