//*****************************************
// AVR ATmega328 8x8 LED Clock
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:setting.c
//
//
//  2023/03/28 New(TAB4) Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"pr_mega328_8x8dot_clock_h.h"
#include	"timer_h.h"
#include	"port_bit_h.h"
#include	"display_h.h"
#include	"dot8x8_h.h"
#include	"eep_dat_h.h"
#include	"uart_h.h"
#include	"infrared_h.h"
#include	"gps_clock_h.h"
#include	"OLED_1306_h.h"
#include	"setting_h.h"


//***************************
// ␳aorUOOvZ
// uc : ^C}[P̃JE^[lłWlgȂ΂VWPR̔
// ␳lVWPRaorQUOO
//***************************
unsigned short calc_bps600(unsigned short us)
{
	unsigned short r;
	unsigned long ul;

	ul = us;
	ul *= (unsigned long)(BPS_600);
	ul /= (unsigned long)7813;
	r = (unsigned short)ul;

	return(r);

}
//***************************
// ␳aorXUOOvZ
// uc : ^C}[P̃JE^[lłWlgȂ΂VWPR̔
// ␳lVWPRaorQXUOO
//***************************
unsigned short calc_bps9600(unsigned short us)
{
	unsigned short r;
	unsigned long ul;

	ul = us;
	ul *= (unsigned long)(BPS_9600);
	ul /= (unsigned long)7813;
	r = (unsigned short)ul;

	return(r);

}

//***************************
// aorUOO̒l`FbN
//  kdcSx_ł
//  XCb`ėꂽ 
//  ^C}[P̒lŏʂɂS\BiWlg҂ȂVWPRj
//  aorUOO̒lŉʂRɕ\BiWlg҂ȂWRRj
//  for̂PbM̃^C~OŃ^C}[P̒lƂaorUOO̒lXV
//  rdsXCb`Zꂽ@݂̂aorUOO
//    aorUOO̒lɏ݁AȌケ̒lg
//  ̓dnmg
//***************************
void	check_bps600(void)
{
	unsigned short	us;
	unsigned short	t1_count = 7813;
	unsigned short	bps600 = 833;
	unsigned short	bps9600 = 51;
	unsigned char	req_disp = 0;					// \v
	unsigned char	uc;
	unsigned char	ucbf[10];

	bps600 = gBPS_600;
	bps9600 = gBPS_9600;

	for(uc = 0;uc <= 7; uc++){
		disp_line_clear_oled_G(uc * 8);				// One Line Clear Display
	}
	disp_oled_G_12x16(0*6, 0*8, (unsigned char *)"CHECK BPS");	// x:0, y:0, "CHECK BPS"

	ucbf[0] = ' ';
	ucbf[1] = 'E';
	ucbf[2] = 'E';
	ucbf[3] = 'P';
	ucbf[4] = '6';
	ucbf[5] = '0';
	ucbf[6] = '0';
	ucbf[7] = ':';
	ucbf[8] = 0;
	disp_oled_G(0*6, 2*8, ucbf);					// x:0, y:2, 9600
	set_binary_4(&(ucbf[0]), bps600);				// SQiimax 9999)AXL[Sɂ
	disp_oled_G(8*6, 2*8, ucbf);					// x:0, y:2, 9600

	ucbf[0] = 'E';
	ucbf[1] = 'E';
	ucbf[2] = 'P';
	ucbf[3] = '9';
	ucbf[4] = '6';
	ucbf[5] = '0';
	ucbf[6] = '0';
	ucbf[7] = ':';
	ucbf[8] = 0;
	disp_oled_G(0*6, 4*8, ucbf);					// x:0, y:4, 9600
	set_binary_4(&(ucbf[0]), bps9600);				// SQiimax 9999)AXL[Sɂ
	disp_oled_G(8*6, 4*8, ucbf);					// x:0, y:4, 9600

//	gps_1sec_init();								// for PbMݐݒ
//
//	get_sw();
//
//	timer1_init();									// Timer1 Initial
//	sei();											// 荞݉
//	delay_ms(10);									// 100mS Delay
//	get_sw();
//	delay_ms(10);									// 100mS Delay
//	get_sw();
//	delay_ms(10);									// 100mS Delay

	led5_off();										// LED1 OFF
	disp_dot8x8_clear();							// \S
	disp_dot8x8_4binary(6,bps600);					// S\iXXXX܂Łj
	disp_dot8x8_all();								// WW S\
	delay_ms(2000);									// 1S Delay

	ucbf[0] = ' ';
	ucbf[1] = 'N';
	ucbf[2] = 'E';
	ucbf[3] = 'W';
	ucbf[4] = '6';
	ucbf[5] = '0';
	ucbf[6] = '0';
	ucbf[7] = ':';
	ucbf[8] = 0;
	disp_oled_G(0*6, 3*8, ucbf);					// x:0, y:3, NOW

	ucbf[0] = 'N';
	ucbf[1] = 'E';
	ucbf[2] = 'W';
	ucbf[3] = '9';
	ucbf[4] = '6';
	ucbf[5] = '0';
	ucbf[6] = '0';
	ucbf[7] = ':';
	ucbf[8] = 0;
	disp_oled_G(0*6, 5*8, ucbf);					// x:0, y:5, NOW

	ucbf[0] = ' ';
	ucbf[1] = ' ';
	ucbf[2] = 'C';
	ucbf[3] = 'O';
	ucbf[4] = 'U';
	ucbf[5] = 'N';
	ucbf[6] = 'T';
	ucbf[7] = ':';
	ucbf[8] = 0;
	disp_oled_G(0*6, 7*8, ucbf);					// x:0, y:7, NOW

	req_disp = 1;									// \vnm

	for(;;){
		if(req_disp == 1){										// \vnm̎
			disp_dot8x8_all();									// WW S\
			req_disp = 0;										// \vnee
		}
		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ

		if(us == SW1_OFF_LONG){									// XCb`ėꂽ(set switch)
			disp_one_char_oled_G(19*6, 7*8, '*');
			write_eep_bps_600(bps600);							//@ddoqnl BPS_600 
			write_eep_bps_9600(bps9600);						//@ddoqnl BPS_9600 
			gBPS_600 = bps600;
			gBPS_9600 = bps9600;
			set_binary_4(&(ucbf[0]), bps600);					// SQiimax 9999)AXL[Sɂ
			disp_oled_G(8*6, 2*8, ucbf);						// x:10, y:2, 600
			set_binary_4(&(ucbf[0]), bps9600);					// SQiimax 9999)AXL[Sɂ
			disp_oled_G(8*6, 4*8, ucbf);						// x:10, y:4, 600
			disp_one_char_oled_G(19*6, 7*8, ' ');
		}else if(us == SW1_OFF_SHORT){							// XCb`Zėꂽ(set switch)
			break;
		}

		if(gGPS_1sec_flag != 0){								// for̂PbMĂ鎞̂Pboߗp
			t1_count = TCNT1;									// sbmsPǂݏo
			TCNT1 = 0;											// sbmsP@NA
			gGPS_1sec_flag = 0;
			tim_10ms_exist_gps1s = 10;
			bps600 = calc_bps600(t1_count);						// ␳aorUOOvZ
			bps9600 = calc_bps9600(t1_count);					// ␳aorXUOOvZ

			disp_dot8x8_4binary(6,bps600);						// S\iXXXX܂Łj
			set_binary_4(&(ucbf[0]), bps600);					// SQiimax 9999)AXL[Sɂ
			disp_oled_G(8*6, 3*8, ucbf);						// x:10, y:3, NOW

			set_binary_4(&(ucbf[0]), bps9600);					// SQiimax 9999)AXL[Sɂ
			disp_oled_G(8*6, 5*8, ucbf);						// x:8, y:5, NOW

			set_binary_4(&(ucbf[0]), t1_count);					// SQiimax 9999)AXL[Sɂ
			disp_oled_G(8*6, 7*8, ucbf);						// x:8, y:7, NOW

			req_disp = 1;										// \vnm
		}

		if(tim_10ms_exist_gps1s != 0){							// forPbԊuMLiforf[^Ԋuj
			led5_on();											// LED5 ON
		}else{
			led5_off();											// LED5 OFF
		}

	}

}

//***************************
// b\̌`ݒ
//***************************
void	set_disp_sec_mode(void)
{
	unsigned short	us;
	unsigned char	old_sel;
	unsigned char	i;
	unsigned char	disp_sec_mode;
	unsigned char	mode_str[4][10]=
		{
			{'N','O','N',0},
			{'V','A','L','U','E',0},
			{'B','L','I','N','K','-','*',0},
			{'H','-','B','A','R',0},
		};
	unsigned char	mode_disp_xpos[4]={9,8,7,8};
	unsigned char	mode_disp_ypos[4]={3,4,5,6};

	disp_sec_mode = gDISP_sec_mode;

	for(i = 0;i <= 7; i++){
		disp_line_clear_oled_G(i * 8);				// One Line Clear Display
	}
	disp_dot8x8_clear();							// WW \S
	disp_dot8x8_moji(5, 'S');						// WW \
	disp_dot8x8_moji(6, 'E');						// WW \
	disp_dot8x8_moji(7, 'C');						// WW \
	disp_dot8x8_moji(8, '-');						// WW \
	disp_dot8x8_number(9, disp_sec_mode);			// WW \
	disp_dot8x8_all();								// WW S\

	disp_oled_G_12x16(0*6, 0*8, (unsigned char *)"SEC MODE");	// x:0, y:0, "SEC MODE"

	for(i=0;i<4;i++){
		if(i==disp_sec_mode){
			disp_oled_G_reverse(mode_disp_xpos[i]*6, mode_disp_ypos[i]*8, mode_str[i]);
		}else{
			disp_oled_G(mode_disp_xpos[i]*6, mode_disp_ypos[i]*8, mode_str[i]);
		}
	}

	old_sel = disp_sec_mode;
	for(;;){
		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ

		if(us == SW1_OFF_LONG){									// XCb`ėꂽ(set switch)
			disp_one_char_oled_G(19*6, 7*8, '*');
			write_eep_DISP_sec_mode(disp_sec_mode);				//@ddoqnl BPS_600 
			gDISP_sec_mode = disp_sec_mode;
			disp_one_char_oled_G(19*6, 7*8, ' ');
		}else if(us == SW1_OFF_SHORT){							// XCb`Zėꂽ(set switch)
			break;
		}else if(us == SW2_OFF_SHORT){							// XCb`Zėꂽ(select switch)
			disp_sec_mode++;
			if(4 <= disp_sec_mode){
				disp_sec_mode = 0;
			}
			disp_dot8x8_number(9, disp_sec_mode);				// WW \
			disp_dot8x8_all();									// WW S\
			disp_oled_G(mode_disp_xpos[old_sel]*6, mode_disp_ypos[old_sel]*8, mode_str[old_sel]);
			disp_oled_G_reverse(mode_disp_xpos[disp_sec_mode]*6, mode_disp_ypos[disp_sec_mode]*8, mode_str[disp_sec_mode]);

			old_sel = disp_sec_mode;
		}
	}
}

//***************************
//  ݒ
//***************************
void	setting(void)
{

	while(1){
		led5_toggle();
		delay_ms(100);								// 100mS Delay
		if((SW_IN_PORT & SW1_ON_BIT) != 0){			// XCb`f[^ꂽ(set switch)
			delay_ms(20);							// 20mS Delay
			if((SW_IN_PORT & SW1_ON_BIT) != 0){		// QxXCb`f[^ꂽ(set switch)
				break;
			}
		}
	}
	led5_off();										// LED5 OFF

	gps_1sec_init();								// for PbMݐݒ

	get_sw();

	timer1_init();									// Timer1 Initial
	sei();											// 荞݉
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay

	while(1){
		check_bps600();								// aorUOO̒l`FbN
		set_disp_sec_mode();						// b\̌`ݒ
	}
}